﻿#region Version Info Header
/*
 * $Id: NotificationExtensions.cs 1070 2010-09-08 12:57:59Z t_rendelmann $
 * $HeadURL: https://rssbandit.svn.sourceforge.net/svnroot/rssbandit/trunk/source/RssBandit.AppServices/Util/NotificationExtensions.cs $
 * Last modified by $Author: t_rendelmann $
 * Last modified at $Date: 2010-09-08 08:57:59 -0400 (Wed, 08 Sep 2010) $
 * $Revision: 1070 $
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Reflection;
using System.Text;

// keep namespace, it is the same as the extendee.
namespace System.ComponentModel
{
  /// <summary>
  /// PropertyChanged helpers
  /// </summary>
  /// <remarks>
  /// From http://www.ingebrigtsen.info/post/2008/12/11/INotifyPropertyChanged-revisited.aspx
  /// </remarks>
  public static class NotificationExtensions
  {
    public static void Notify(this PropertyChangedEventHandler eventHandler, Expression<Func<object>> expression)
    {
      if (null == eventHandler)
      {
        return;
      }
      LambdaExpression lambda = expression;
      MemberExpression memberExpression;
      if (lambda.Body is UnaryExpression)
      {
        UnaryExpression unaryExpression = lambda.Body as UnaryExpression;
        memberExpression = unaryExpression.Operand as MemberExpression;
      }
      else
      {
        memberExpression = lambda.Body as MemberExpression;
      }
      ConstantExpression constantExpression = memberExpression.Expression as ConstantExpression;
      PropertyInfo propertyInfo = memberExpression.Member as PropertyInfo;

      eventHandler(constantExpression.Value, new PropertyChangedEventArgs(propertyInfo.Name));
    }
  }
}
;