﻿using System;
using System.Collections.Generic;
using System.Diagnostics.Contracts;
using System.Linq;
using System.Text;
using System.Windows;

namespace OpenSearch.Controls
{
    public class SearchRequestedEventArgs : RoutedEventArgs
    {
        public SearchRequestedEventArgs(Uri searchAddress, bool newWindow)
            : base(SearchBox.SearchRequestedEvent)
        {
            Contract.Requires(searchAddress != null);

            NewWindow = newWindow;
            SearchAddress = searchAddress;
        }
        public bool NewWindow { get; private set; }
        public Uri SearchAddress { get; private set; }
    }

    public delegate void SearchRequestedEventHandler(object sender, SearchRequestedEventArgs e);
}
